1#!/bin/bash
2# Copyright (C) 1996-2022 Free Software Foundation, Inc.
3# This file is part of the GNU C Library.
4
5# The GNU C Library is free software; you can redistribute it and/or
6# modify it under the terms of the GNU Lesser General Public
7# License as published by the Free Software Foundation; either
8# version 2.1 of the License, or (at your option) any later version.
9
10# The GNU C Library is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
13# Lesser General Public License for more details.
14
15# You should have received a copy of the GNU Lesser General Public
16# License along with the GNU C Library; if not, see
17# <https://www.gnu.org/licenses/>.
18
19
20# This is the `ldd' command, which lists what shared libraries are
21# used by given dynamically-linked executables.  It works by invoking the
22# run-time dynamic linker as a command and setting the environment
23# variable LD_TRACE_LOADED_OBJECTS to a non-empty value.
24
25# We should be able to find the translation right at the beginning.
26TEXTDOMAIN=libc
27TEXTDOMAINDIR=@TEXTDOMAINDIR@
28
29RTLDLIST=@RTLD@
30warn=
31bind_now=
32verbose=
33
34while test $# -gt 0; do
35  case "$1" in
36  --vers | --versi | --versio | --version)
37    echo 'ldd @PKGVERSION@@VERSION@'
38    printf $"Copyright (C) %s Free Software Foundation, Inc.
39This is free software; see the source for copying conditions.  There is NO
40warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
41" "2022"
42    printf $"Written by %s and %s.
43" "Roland McGrath" "Ulrich Drepper"
44    exit 0
45    ;;
46  --h | --he | --hel | --help)
47    echo $"Usage: ldd [OPTION]... FILE...
48      --help              print this help and exit
49      --version           print version information and exit
50  -d, --data-relocs       process data relocations
51  -r, --function-relocs   process data and function relocations
52  -u, --unused            print unused direct dependencies
53  -v, --verbose           print all information
54"
55    printf $"For bug reporting instructions, please see:\\n%s.\\n" \
56      "@REPORT_BUGS_TO@"
57    exit 0
58    ;;
59  -d | --d | --da | --dat | --data | --data- | --data-r | --data-re | \
60  --data-rel | --data-relo | --data-reloc | --data-relocs)
61    warn=yes
62    shift
63    ;;
64  -r | --f | --fu | --fun | --func | --funct | --functi | --functio | \
65  --function | --function- | --function-r | --function-re | --function-rel | \
66  --function-relo | --function-reloc | --function-relocs)
67    warn=yes
68    bind_now=yes
69    shift
70    ;;
71  -v | --verb | --verbo | --verbos | --verbose)
72    verbose=yes
73    shift
74    ;;
75  -u | --u | --un | --unu | --unus | --unuse | --unused)
76    unused=yes
77    shift
78    ;;
79  --v | --ve | --ver)
80    echo >&2 $"ldd: option \`$1' is ambiguous"
81    exit 1
82    ;;
83  --)		# Stop option processing.
84    shift; break
85    ;;
86  -*)
87    echo >&2 'ldd:' $"unrecognized option" "\`$1'"
88    echo >&2 $"Try \`ldd --help' for more information."
89    exit 1
90    ;;
91  *)
92    break
93    ;;
94  esac
95done
96
97nonelf ()
98{
99  # Maybe extra code for non-ELF binaries.
100  return 1;
101}
102
103add_env="LD_TRACE_LOADED_OBJECTS=1 LD_WARN=$warn LD_BIND_NOW=$bind_now"
104add_env="$add_env LD_VERBOSE=$verbose"
105if test "$unused" = yes; then
106  add_env="$add_env LD_DEBUG=\"$LD_DEBUG${LD_DEBUG:+,}unused\""
107fi
108
109# The following command substitution is needed to make ldd work in SELinux
110# environments where the RTLD might not have permission to write to the
111# terminal.  The extra "x" character prevents the shell from trimming trailing
112# newlines from command substitution results.  This function is defined as a
113# subshell compound list (using "(...)") to prevent parameter assignments from
114# affecting the calling shell execution environment.
115try_trace() (
116  output=$(eval $add_env '"$@"' 2>&1; rc=$?; printf 'x'; exit $rc)
117  rc=$?
118  printf '%s' "${output%x}"
119  return $rc
120)
121
122case $# in
1230)
124  echo >&2 'ldd:' $"missing file arguments"
125  echo >&2 $"Try \`ldd --help' for more information."
126  exit 1
127  ;;
1281)
129  single_file=t
130  ;;
131*)
132  single_file=f
133  ;;
134esac
135
136result=0
137for file do
138  # We don't list the file name when there is only one.
139  test $single_file = t || echo "${file}:"
140  case $file in
141  */*) :
142       ;;
143  *) file=./$file
144     ;;
145  esac
146  if test ! -e "$file"; then
147    echo "ldd: ${file}:" $"No such file or directory" >&2
148    result=1
149  elif test ! -f "$file"; then
150    echo "ldd: ${file}:" $"not regular file" >&2
151    result=1
152  elif test -r "$file"; then
153    test -x "$file" || echo 'ldd:' $"\
154warning: you do not have execution permission for" "\`$file'" >&2
155    RTLD=
156    ret=1
157    for rtld in ${RTLDLIST}; do
158      if test -x $rtld; then
159	verify_out=`${rtld} --verify "$file"`
160	ret=$?
161	case $ret in
162	[02]) RTLD=${rtld}; break;;
163	esac
164      fi
165    done
166    case $ret in
167    1)
168      # This can be a non-ELF binary or no binary at all.
169      nonelf "$file" || {
170	echo $"	not a dynamic executable" >&2
171	result=1
172      }
173      ;;
174    0|2)
175      try_trace "$RTLD" "$file" || result=1
176      ;;
177    *)
178      echo 'ldd:' ${RTLD} $"exited with unknown exit code" "($ret)" >&2
179      exit 1
180      ;;
181    esac
182  else
183    echo 'ldd:' $"error: you do not have read permission for" "\`$file'" >&2
184    result=1
185  fi
186done
187
188exit $result
189# Local Variables:
190#  mode:ksh
191# End:
192